/*
 * $Header: /home/cvspublic/jakarta-commons-sandbox/resources/src/test/org/apache/commons/resources/impl/CollResources.java,v 1.1 2003/01/05 03:29:58 craigmcc Exp $
 * $Revision: 1.1 $
 * $Date: 2003/01/05 03:29:58 $
 *
 * ====================================================================
 *
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 1999-2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Commons", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 */


package org.apache.commons.resources.impl;


import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.Reader;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.TimeZone;
import org.apache.commons.resources.Resources;
import org.apache.commons.resources.ResourcesException;
import org.apache.commons.resources.ResourcesKeyException;


/**
 * <p>Concrete implementation of {@link Resources} for unit tests.</p>
 *
 * <p><strong>IMPLEMENTATION NOTE</strong> - The set of hard-coded resource
 * maps returned by <code>getLocaleMap()</code> below must *exactly*
 * match the resources stored in the <code>TestResources*.properties</code>
 * and <code>TestResources*.xml</code> resource files.</p>
 *
 * @author Craig R. McClanahan
 * @version $Revision: 1.1 $ $Date: 2003/01/05 03:29:58 $
 */

public class CollResources extends CollectionResourcesBase {


    // ----------------------------------------------------------- Constructors


    // Construct a test instance with the specified name and base URL
    public CollResources(String name, String base) {
        super(name, base);
    }


    // ----------------------------------------------------- Instance Variables


    // ------------------------------------------------------ Lifecycle Methods


    // ------------------------------------------------------------- Properties


    // ---------------------------------------------- Content Retrieval Methods


    // Concrete implementation of getLocaleMap()
    protected Map getLocaleMap(String base, Locale locale) {

        String language = locale.getLanguage();
        String country = locale.getCountry();
        String variant = locale.getVariant();
        if (variant.length() > 0) {
            return (new HashMap());
        }

        if (language.equals("en")) {
            if (country.equals("US")) {
                Map map = new HashMap();
                map.put("test.specific", "[en_US] SPECIFIC");
                return (map);
            } else if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.specific", "[en] SPECIFIC");
                map.put("test.inherit", "[en] INHERIT");
                return (map);
            } else {
                return (new HashMap());
            }
        } else if (language.equals("fr")) {
            if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.specific", "[fr] SPECIFIC");
                map.put("test.inherit", "[fr] INHERIT");
                return (map);
            } else {
                return (new HashMap());
            }
        } else if (language.equals("")) {
            if (country.equals("")) {
                Map map = new HashMap();
                map.put("test.base", "[Base] ONLY");
                map.put("test.specific", "[Base] SPECIFIC");
                map.put("test.inherit", "[Base] INHERIT");
                map.put("test.message", "[Base] REPLACE {0} WITH {1}");
                return (map);
            } else {
                return (new HashMap());
            }
        } else {
            return (new HashMap());
        }
    }


}
